<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Requisition_Model extends CI_Model {
  
  private $tableName = 'requisition';
  
  function __construct() 
  {
    /* Call the Model constructor */
    parent::__construct();
  }
  
  
  
  
   //Sales best for dashboard
   function getBestSales($year=null,$month=0,$from=0,$to=0){
	$this->db->select('SUM(ft.fi_qty)AS fi_qty_tot,p.product_name,p.product_code,p.product_part_no,p.product_oem_part_number');
	$this->db->from('fi_table ft');
	$this->db->join('product p', 'ft.fi_item_id = p.product_id', 'left');
	$this->db->where('ft.fi_type_id', 'sale');
	if($month){
		$this->db->where('MONTH(ft.fi_date_time)', $month , FALSE);
	}
	if($year){
		$this->db->where('YEAR(ft.fi_date_time)', $year , FALSE);
	}
	if($to){
		$this->db->limit($to,$from);
	}
	$this->db->order_by("fi_qty_tot", "desc");
	$this->db->group_by('ft.fi_item_id');
	$query=$this->db->get();
	return $query->result();
  }  
  
  //Sales genarate referance number
  function get_next_ref_no($w){
	  $this->db->select_max('warehouse_req__id');
	  $this->db->where("warehouse_id", $w);
	  return $this->db->get('requisition');
  }
 
  //Sales get avalable product qty
  function get_avalable_product_qty($product_id,$warehouse_id){
		$this->db->select_sum('fi_qty');
		$query = $this->db->get('fi_table');
		return $query->row()->fi_qty;
  }
  

  
    //Sales get information
	public function get_req_info($id)
	 {
		$this->db->select('r.*,w.*');
		$this->db->from('requisition r');
		$this->db->join('warehouses w', 'w.id = r.warehouse_id', 'left');
		$this->db->where("r.req_id", $id);
		$this->db->order_by("r.req_id", "desc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result(); 
	 }
	 
	 public function get_po_info_by_req_id($req_id)//test
	 {
		$this->db->select('po.*');
		$this->db->from('purchases_order po');
		//$this->db->join('warehouses w', 'w.id = r.warehouse_id', 'left');
		$this->db->where("po.req_id", $req_id);
		//$this->db->order_by("r.req_id", "desc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result(); 
	 }
	 
	     //Sales get information
	public function get_req_info_2($id)
	 {
		 if($id){
		$this->db->select('r.*');
		$this->db->from('requisition r');
		$this->db->where("r.req_id", $id);
		$this->db->order_by("r.req_id", "desc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		$des=$query->row_array(); 
		return $des['req_reference_no']; 
		//return '1';
		 }else {
			 return '0';
		 }
	 }

    //Sales get information
	public function get_requisition_items_by_id($req_id)
	 {
		$this->db->select('ri.*,p.product_code,p.product_part_no');
		$this->db->from('requisition_items ri');
		$this->db->join('product p', 'ri.product_id = p.product_id', 'left');
		$this->db->where("ri.req_id", $req_id);
		//$this->db->order_by("ri.req_id", "desc");
		$this->db->order_by("p.product_name", "asc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result(); 
	 }
	 
	 public function get_requisition_items_by_id_and_product_id($req_id,$product_id)
	 {
		$this->db->select('ri.*,p.product_code,p.product_part_no');
		$this->db->from('requisition_items ri');
		$this->db->join('product p', 'ri.product_id = p.product_id', 'left');
		$this->db->where("ri.req_id", $req_id);
		$this->db->where("ri.product_id", $product_id);
		$this->db->order_by("ri.req_id", "desc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result(); 
	 }
	 
	  public function get_requisition_items_qty_by_id_and_product_id($req_id,$product_id)
	 {
		$this->db->select_sum('ri.qs_approud_qty');
		$this->db->from('requisition_items ri');
		$this->db->join('product p', 'ri.product_id = p.product_id', 'left');
		$this->db->join('requisition r', 'ri.req_id = r.req_id', 'left');
		$this->db->where("ri.req_id", $req_id);
		$this->db->where("ri.product_id", $product_id);
		$this->db->where("r.requisitioned_status", 'Requisitioned');
		$this->db->where("r.approved_status", 'Approved');
		$this->db->where("r.authorized_status", 'Authorized');
		$this->db->where("r.cancel_status", '');
		$this->db->order_by("ri.req_id", "desc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->row()->qs_approud_qty; 
	 }
	 
	  public function get_po_items_qty_by_id_and_product_id($req_id,$product_id)
	 {
		$this->db->select_sum('poi.poitm_qty');
		$this->db->from('purchases_order_items poi');
		$this->db->join('product p', 'poi.product_id = p.product_id', 'left');
		$this->db->join('purchases_order po', 'poi.po_id = po.po_id', 'left');
		$this->db->where("po.req_id", $req_id);
		$this->db->where("poi.product_id", $product_id);
		//$this->db->order_by("ri.req_id", "desc");
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->row()->poitm_qty; 
	 }
	 
	     //Sales get information
	public function get_requisition_details_by_id($req_id)
	 {
		$this->db->select('r.*,w.*');
		$this->db->from('requisition r');
		$this->db->join('warehouses w', 'w.id = r.warehouse_id', 'left');
		$this->db->where("r.req_id", $req_id);
		$this->db->order_by("r.req_id", "desc");
		$query = $this->db->get();  
		//echo $this->db->last_query();
		return $query->row();
	 }
	 	 
	 
	 
	//Sales item list get by id 
	public function get_req_item_list_by_req_id($req_id)
	 {
		$this->db->select('ri.*,u.*,w.*,p.product_code,p.product_part_no');
		$this->db->from('requisition_items ri');
		$this->db->join('product p', 'ri.product_id = p.product_id', 'left');
		$this->db->join('mstr_unit u', 'u.unit_id = ri.product_unit', 'left');
		$this->db->join('requisition r', 'r.req_id = ri.req_id', 'left');
		$this->db->join('warehouses w', 'w.id = r.warehouse_id', 'left');
		//$this->db->order_by("ri.reqitm_id", "asc");
		$this->db->order_by("p.product_name", "asc");
		$this->db->where("ri.req_id", $req_id);//("id !=",$id);
		$query = $this->db->get();
		return $query->result();
		
	 }

	//Sales save
	function save_requisition(&$supplier_data,$req_id=false)
	{
		if (!$req_id)
		{
			$this->db->insert($this->tableName,$supplier_data);
		}else {
			$this->db->where('req_id', $req_id);
			return $this->db->update($this->tableName,$supplier_data);
		}
	}	
	
	//Sales item save
	function save_requisition_item(&$data_item)
	{
			$this->db->insert('requisition_items',$data_item);
	}
	
	
	function update_requisition_item(&$data_item,$id)
	{
		$this->db->where('reqitm_id', $id);
		return $this->db->update('requisition_items',$data_item);	
	}	

	//Sales get for report
	function get_all_requisition_for_report($srh_warehouse_id='',$srh_to_date='',$srh_from_date='',$req_id='',$from='',$to='') {
		$this->db->select('s.* , c.cus_name');
		$this->db->from('requisition s');
		$this->db->join('customer c', 's.customer_id = c.cus_id', 'left');
		
		$this->db->order_by("s.req_id", "asc");
		$this->db->group_by('s.req_id');
		if($srh_warehouse_id){
			$this->db->where("s.warehouse_id",$srh_warehouse_id);//("id !=",$id);
		}
		if($srh_to_date){
			$this->db->where("s.req_datetime <=",$srh_to_date);//("id !=",$id);
		}
		if($srh_from_date){
			$this->db->where("s.req_datetime >=",$srh_from_date);//("id !=",$id);
		}
		if($req_id){
			$this->db->where("s.req_id =",$req_id);//("id !=",$id);
		}
		if($to){
		$this->db->limit($to,$from);
		}
		$query = $this->db->get();
		return $query->result_array();
	}	
	
	//Sales all get
	function get_all_requisition($warehouse_id='') {
		//$warehouse_id=1;
		$this->db->select('r.*,w.*');
		$this->db->from('requisition r');
		$this->db->join('warehouses w', 'w.id = r.warehouse_id', 'left');
		$this->db->order_by("r.req_id", "desc");
		$this->db->where("r.req_id IS NOT NULL");//("id !=",$id);
		if($warehouse_id){
		$this->db->where("r.warehouse_id",$warehouse_id);
		}
		//echo $warehouse_id;
		//$this->db->where("r.requisitioned_status",);
		$this->db->limit(800);
		$query = $this->db->get();
		
		//echo 'test';
		
		return $query->result_array();
	}
	
		function get_all_requisition_names() {
		$this->db->select('r.*,w.*');
		$this->db->from('requisition r');
		$this->db->join('warehouses w', 'w.id = r.warehouse_id', 'left');
		$this->db->order_by("r.req_id", "desc");
		$this->db->where("r.req_id IS NOT NULL");//("id !=",$id);
		$query = $this->db->get();
		//echo $this->db->last_query();
		return $query->result();
	}
	
	
	//Sales get for print
	function get_all_requisition_for_print_requisition() {
		$this->db->select('s.* , c.cus_name ');
		$this->db->from('requisition s');
		$this->db->join('customer c', 's.customer_id = c.cus_id', 'left');
	
		$this->db->order_by("s.req_id", "desc");
		$this->db->group_by('s.req_id');
		$this->db->where("s.req_id IS NOT NULL");//("id !=",$id);
		$query = $this->db->get();
		return $query->result_array();
	}
	
	public function delete_old_requisition_items($req_id)
	{
		$this->db->where('req_id', $req_id);
		$this->db->delete('requisition_items');
	}
	

	
	//Get product sujetions
	function get_products_suggestions($term) {
		$this->db->select('product'.'.*');
		$this->db->order_by("product_name", "asc");
		//$this->db->where("product_name LIKE '%$term%'");
		$this->db->where("product_name LIKE '%$term%' OR product_code LIKE '%$term%' OR product_oem_part_number LIKE '%$term%' OR product_part_no LIKE '%$term%'");
		 $this->db->limit(10, 0);
		$query = $this->db->get('product');
		//echo $this->db->last_query();
		return $query->result_array();
	}
	
	//Get all products
	function get_all_products() {
		$this->db->select('product'.'.*');
		$this->db->order_by("product_name", "asc");
		$this->db->where("product_id IS NOT NULL");//("id !=",$id);
		$query = $this->db->get('product');
		return $query->result_array();
	}
	
	
}